-- 'Basic' version of OmniCC

local F, C, L = unpack(select(2, ...))

local format, floor, GetTime= string.format, math.floor, GetTime
local Multiplier = 0.8

local function GetFormattedTime(s)
	if s>3600 then
		return format("%dh", floor(s/3600 + 0.5)), s % 3600
	elseif s>60 then
		return format("%dm", floor(s/60 + 0.5)), s % 60
	end
	return floor(s + 0.5), s - floor(s)
end

local function Timer_OnUpdate(self, elapsed)
	if self.text:IsShown() then
		if self.nextUpdate>0 then
			self.nextUpdate = self.nextUpdate - elapsed
		else
			local remain = self.duration - (GetTime() - self.start)
			if floor(remain + 0.5) > 0 then
				local time, nextUpdate = GetFormattedTime(remain)
				self.text:SetText(time)
				self.nextUpdate = nextUpdate
			else
				self.text:Hide()
			end
		end
	end
end

local methods = getmetatable(ActionButton1Cooldown).__index
hooksecurefunc(methods, "SetCooldown", function(self, start, duration)
	if(start>0 and duration>2.5) then
		local rsize = self:GetParent():GetWidth() * Multiplier
		if(rsize<10) then return end

		self.start = start
		self.duration = duration
		self.nextUpdate = 0

		local text = self.text
		if(not text) then
			text = F.CreateFS(self, 8, "CENTER")
			if C.general.hotkey == true then text:SetPoint("CENTER", 1, 0) else text:SetPoint("BOTTOM", 1, -1) end
			self.text = text
			self:SetScript("OnUpdate", Timer_OnUpdate)
		end

		text:Show()
	elseif(self.text) then
		self.text:Hide()
	end
end)